//#pragma once
//t@Co͗p
#include <fstream>
#include <iostream>
#include <ios>
#include <cassert>

//Ԍvp
#include <time.h>
#include <sstream>

#include <BWAPI.h>
#include <BWTA.h>
#include <boost/random.hpp>
//#include <boost/random/random_device.hpp> G[ôŉ

#include "Typedef.h"


#include "PlayerData.h"
#include "AttackerData.h"
#include "BuildingData.h"
#include "ResourceData.h"
#include "WorkerData.h"
#include "LarvaData.h"
#include "OtherUnitData.h"
#include "MapData.h"



class PlayerData;
class AttackerData;
class BuildingData;
class ResourceData;
class WorkerData;
class LarvaData;
class OtherUnitData;
class MapData;


namespace AttackerState {
	extern const int None, Attack, Retreat, Defense, Scout, Max;
}

namespace WorkerState {
	extern const int None, Mineral, Gas, Build, Attack, Max;
}

namespace BuildingState {
	extern const int None, Execute, Constructing, Completed, Max;
}

namespace OtherUnitState{
	extern const int None, Scout, Detect, Max;
}

namespace ResourceState{
	extern const int None, Mine, Enemy, Max;
}

namespace MyBaseProductState{
	extern const int Worker, Attacker, Max;
}

namespace BuildOrderType{
	extern const int Brooding, 
		             Defiler,
					 Hydralisk,
					 Lurker,
					 Ultralisk,
					 Zergling,
					 Devourer,
					 Guardian,
					 Mutalisk,
					 Overload,
					 Queen,
					 Scourge,
					 CreepColony,
					 DefilerMound,
					 EvolutionChamber,
					 Extractor,
					 GreaterSpire,
					 Hatchery,
					 Hive,
					 HydraliskDen,
					 Lair,
					 NydusCanel,
					 QueensNest,
					 SpawningPool,
					 Spire,
					 SporeColony,
					 SunkenColony,
					 UltraliskCavern,
					 Carapace,
					 MeleeAtack,
					 MetasynapticNode,
					 MissileAttacks,
					 MuscularAugment,
					 GroovedSpines,
					 ChitinousPlating,
					 AnabolicSynthesis,
					 MetabolicBoost,
					 AdrenalGlands,
					 FlyerCarapace,
					 FlyerAttacks,
					 VentralSacs,
					 Antennae,
					 PneumatizedCarapace,
					 GameteMeiosis,
					 Burrowing,
					 DarkSwarm,
					 Plague,
					 Consume,
					 LurkerAspect,
					 Infestation,
					 SpawnBroodings,
					 Ensnare,
					 Parasite,
					 Base,
					 Max;
}


namespace CimexFlag{
	extern bool scout_flag;
	extern bool next_mybase_flag;
	extern bool enemy_air_weapon;
	extern bool no_resource_flag;
}


namespace BuildOrderData{
	extern int drone_num;
/*	extern int overload_num;
	extern int hatchery_num;
	extern int lair_num;
	extern int hive_num;
	extern int base_num;
	extern int pool_num;
	extern int zergling_num;
	extern int hydralisk_num;
	extern int mutalisek_num;
	extern int extractor_num;
	extern int hydraden_num;
	extern int creep_num;
	extern int sunken_num;
	extern int spire_num;*/
	extern int hold_num[54];
	extern int build_order_index;
}



extern std::set<WorkerData> workers;
extern std::set<AttackerData> attackers;
extern std::set<BuildingData> buildings;
extern std::set<ResourceData> resources;
extern std::set<LarvaData> larvas;
extern std::set<OtherUnitData> others;
extern MapData mapdata;
extern PlayerData playerdata;

extern std::set<WorkerData> eworkers;
extern std::set<AttackerData> eattackers;
extern std::set<BuildingData> ebuildings;
extern std::set<OtherUnitData> eothers;
extern std::set<int> epre_id;

extern const int DINF;
extern const int dx[8];
extern const int dy[8];

extern const bool logging_flag;
extern const bool logging_flag2;
extern const bool build_order_log;

extern const int timex1;
extern const int timex2;

extern std::ofstream out;
extern std::ofstream out2;
extern std::ofstream out3;
extern std::ofstream out4;
extern std::ofstream build_order_out;

extern std::ifstream gbo_in;
extern std::ofstream gbo_out;
extern bool gbotx_er;
extern int strategy_num;
extern int winning_streak;

extern BWAPI::Position ppp;
extern BWTA::BaseLocation* temp_next_mybase;
extern int build_order[102][54];
