#include "LarvaManager.h"

LarvaManager::LarvaManager(void)
{
}


LarvaManager::~LarvaManager(void)
{
}


void LarvaManager::update(){

}


bool LarvaManager::morph(BWAPI::UnitType type) const{
	bool flag = false;
	BOOST_FOREACH(LarvaData &l, larvas){
		if(logging_flag2) out2 << l.getId();
		//if(l.getUnit()->getType() != BWAPI::UnitTypes::Zerg_Larva){ out2 << "#"; continue;}
		if(!l.isMorphing() && BWAPI::Broodwar->getFrameCount() - l.getMorphFrame() > 10){
			if(logging_flag2) out2 << "->clear";
			l.setBuildtype(BWAPI::UnitTypes::None);
			l.setIsMorphing(false);
			l.setMorphFrame(BWAPI::Broodwar->getFrameCount());
		}
		if(l.isMorphing() || l.getBuildtype() != BWAPI::UnitTypes::None){
			if(logging_flag2) out2 << ",";
			continue;
		}

		l.setMorphFrame(BWAPI::Broodwar->getFrameCount());

		l.setBuildtype(type);
		l.getUnit()->morph(type);
		flag = true;
		break;
	}
	return flag;
}

void LarvaManager::createLarva(BWAPI::Unit *unit){
	larvas.insert(LarvaData(unit));
}

void LarvaManager::removeLarva(BWAPI::Unit *unit){
	LarvaData temp_larva;
	BOOST_FOREACH(LarvaData l, larvas){
		if(l.getId() == unit->getID()) temp_larva = l;
	}
	if(temp_larva.getId() != -1){
		larvas.erase(temp_larva);
	}
}