#include "OtherUnitData.h"

//Overload̂߂̃NXɂȂ肻
OtherUnitData::OtherUnitData(BWAPI::Unit * u) : 
	UnitData(u),
	state(OtherUnitState::None),
	now_location(NULL),
	goal(BWAPI::Positions::None)
{
}

OtherUnitData::OtherUnitData(void) :
	UnitData()
{}

OtherUnitData::~OtherUnitData(void){}

void OtherUnitData::update(){
	unit_update();
	hp = getUnit()->getHitPoints();
	if(getUnit()->getType() == BWAPI::UnitTypes::Zerg_Overlord)
	{
		if(state == OtherUnitState::None){
				state = OtherUnitState::Scout;
		}
	}
}

void OtherUnitData::eupdate(){
	if(getUnit()->isVisible()){
		unit_update();
		hp = getUnit()->getHitPoints();
	}
}

char * OtherUnitData::getStateChar() const
{
	if(state == 0) return "None";
	else if(state == 1) return "Scout";
	else if(state == 2) return "Detect";
	else return "????";
}

int OtherUnitData::getState() const
{ return state;}

int OtherUnitData::getHp()const
{ return hp;}

BWAPI::Position OtherUnitData::getGoal()const
{ return goal;}

BWTA::BaseLocation* OtherUnitData::getNowLocation() const
{ return now_location;}

void OtherUnitData::setNowLocation(BWTA::BaseLocation* b){
	now_location = b;
}

void OtherUnitData::setState(const int &i){
	if(i >= OtherUnitState::Max) return;
	state = i;
	return;
}

void OtherUnitData::setGoal(const BWAPI::Position p){
	if(!p.isValid()) return;
	goal = p;
	return;
}