#pragma once
#include "ConstructionManager.h"
#include "ProductionManager.h"
#include "GenerateBuildOrder.h"

class BuildOrderManager
{
private:
	
public:
	ConstructionManager constructionManager;
	ProductionManager productionManager;
	GenerateBuildOrder generateBuildOrder;

	BuildOrderManager(void);
	~BuildOrderManager(void);

	void init();

	void update();

	bool checkComplete(int index);

	bool searchBuildOrder();

	BWAPI::UnitType getUnitType(int type);

	BWAPI::UpgradeType getUpgradeType(int type);

	BWAPI::TechType getTechType(int type);

	void countHoldNum();
};

