#pragma once
#include "UnitManager.h"
#include "Const.h"

class WorkerManager : public UnitManager
{
private:
	int build_flag;

public:

	WorkerManager(void);

	~WorkerManager(void);

	void update();

	bool canBuild(BWAPI::UnitType type);

	void build(WorkerData &w);

	void removeWorker(BWAPI::Unit *unit);

	void createWorker(BWAPI::Unit *unit);

	BWAPI::TilePosition spiralBuildSerch(BWAPI::TilePosition tile, BWAPI::UnitType type);

};

